
// declarations
// data packet constants
  #define START_BYTE 42   //    42 = *
  #define DELIMITER  44    //    44 = ,
  #define END_BYTE   35   //    35 = #

//  sensor constants and Array
//  This code assumes your circuits are connected to sequentially numbered
//  I/O PINs (ie. pins 3,4,5 etc)
   #define firstSensor 3              // pin to which first sensor is connected
   #define MAX_NUMBER_SENSORS 3       // the number of sensors you will read

   int sensors[MAX_NUMBER_SENSORS];   // array to store sensor data

void setup(){

     Serial.begin(9600);   // start serial
  
     for (int i = 0; i < (MAX_NUMBER_SENSORS); i ++) {             
          pinMode(( firstSensor + i ), INPUT );   
     }

}

void loop(){
    // waits for processing to send a message
    // this is a way of having Processing control the flow of data 
    // nothing is sent until Processing asks for it -- like saying "send now"
   
    if ( Serial.available() > 0 ) {  
        readSensors();
        sendSensors();
        Serial.flush(); 
    }

    // other code goes here
    
}


void readSensors(){
    
     // read the variable resistor (sensor)
     for (int i = 0; i < MAX_NUMBER_SENSORS; i ++) {  
             
           // uncomment for digital read
             int position = digitalRead(i + firstSensor) ;  // offset for first sensor
           // uncomment for analog read
             // int position = analogRead(i + firstSensor) / 4 ;  // analog data is 10 bit
                                                                  // so it is divided by 4 before sending
           
            sensors[i] = position;
          
     }
     
}
    
void sendSensors(){
    
    // built and send package
    Serial.print(START_BYTE, BYTE);     // send START_BYTE as a BYTE 
    
    for (int i = 0; i < MAX_NUMBER_SENSORS; i ++) {   
    
            Serial.print(sensors[i], DEC);     // send the sensorValues out via USB as a DECimal
            Serial.print(DELIMITER, BYTE);     // commas separate data
    }
   
    Serial.print(END_BYTE, BYTE);                // end of message
    
}

